<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>How data types map between WinCC OA and DIP</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head>

<body>
<h1>How data types map between WinCC OA and DIP</h1>
<h2>From DIP to WinCC OA</h2>
<p>I.E. The API manager configured as a Client</p>
<table width="100%" border="1">
  <tr>
    <td width="28%">DIP type</td>
    <td width="30%">WinCC OA type</td>
    <td width="42%">Comments</td>
  </tr>
  <tr>
    <td>TYPE_BOOLEAN</td>
    <td>DPELEMENT_BIT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_BYTE</td>
    <td>DPELEMENT_32BIT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_SHORT</td>
    <td>DPELEMENT_INT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_INT</td>
    <td>DPELEMENT_INT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_LONG</td>
    <td><font color="#FF0000">DPELEMENT_INT</font></td>
    <td>DIP type is 64bit WinCC OA type is 32 bit =&gt; loss of precission.</td>
  </tr>
  <tr>
    <td>TYPE_FLOAT</td>
    <td>DPELEMENT_FLOAT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_DOUBLE</td>
    <td><font color="#FF0000">DPELEMENT_FLOAT</font></td>
    <td>DIP type is 64bit WinCC OA type is 32 bit =&gt; loss of precission.</td>
  </tr>
  <tr>
    <td>TYPE_STRING</td>
    <td>DPELEMENT_TEXT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_BOOLEAN_ARRAY</td>
    <td>DPELEMENT_DYNBIT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_BYTE_ARRAY</td>
    <td>DPELEMENT_DYN32BIT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_SHORT_ARRAY</td>
    <td>DPELEMENT_DYNINT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_INT_ARRAY</td>
    <td>DPELEMENT_DYNINT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_LONG_ARRAY</td>
    <td><font color="#FF0000">DPELEMENT_DYNINT</font></td>
    <td>DIP type is array 64 bit values WinCC OA type is list of 32 bit value =&gt;
    loss of precission.</td>
  </tr>
  <tr>
    <td>TYPE_FLOAT_ARRAY</td>
    <td>DPELEMENT_DYNFLOAT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>TYPE_DOUBLE_ARRAY</td>
    <td><font color="#FF0000">DPELEMENT_DYNFLOAT</font></td>
    <td>DIP type is array 64 bit values WinCC OA type is list of 32 bit value =&gt; loss
    of precission.</td>
  </tr>
  <tr>
    <td>TYPE_STRING_ARRAY</td>
    <td>DPELEMENT_DYNTEXT</td>
    <td>&nbsp;</td>
  </tr>
</table>
<p></p>
<h2>From WinCC OA to DIP</h2>
<p>I.E. The API manager configured as a Publisher.</p>
<table width="100%" border="1">
  <tr>
    <td width="28%">WinCC OA type</td>
    <td width="30%">DIP type</td>
    <td width="42%">Comments</td>
  </tr>
  <tr>
    <td>DPELEMENT_BIT</td>
    <td>TYPE_BOOLEAN</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>DPELEMENT_CHAR</td>
    <td>TYPE_STRING</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>DPELEMENT_INT</td>
    <td>TYPE_INT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>DPELEMENT_32BIT</td>
    <td>TYPE_INT</td>
    <td>It must be made clear to clients that this is a bit field - at times
       the value will go negative.</td>
  </tr>
<tr>
    <td>DPELEMENT_UINT</td>
    <td>TYPE_LONG</td>
    <td>Mapped to long so that the sign is preserved.</td>
  </tr>
  <tr>
    <td>DPELEMENT_FLOAT</td>
    <td>TYPE_FLOAT</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>DPELEMENT_TEXT</td>
    <td>TYPE_STRING</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>DPELEMENT_DYNBIT</td>
    <td>TYPE_BOOLEAN_ARRAY</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>DPELEMENT_DYNCHAR</td>
    <td>TYPE_STRING_ARRAY</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>DPELEMENT_DYNINT</td>
    <td>TYPE_INT_ARRAY</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>DPELEMENT_DYN32BIT</td>
    <td>TYPE_INT_ARRAY</td>
    <td>It must be made clear to clients that this is a bit field array - at
      times the value will go negative.</td>
  </tr>
  <tr>
    <td>DPELEMENT_DYNUINT</td>
    <td>TYPE_LONG_ARRAY</td>
    <td>Mapped to long array so that the sign of each element is preserved.</td>
  </tr>
  <tr>
    <td>DPELEMENT_DYNFLOAT</td>
    <td>TYPE_FLOAT_ARRAY</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>DPELEMENT_DYNTEXT</td>
    <td>TYPE_STRING_ARRAY</td>
    <td>&nbsp;</td>
  </tr>
</table>
<p></p>
Note that this does not cover all DPE data types supported by WinCC OA. Currently
  the following are not supported by the API manager.<ul><li>time</li>
  <li>blob</li>
  <li>lanstring</li>
  <li>dyn* versions of the above</li>
</ul>
<p>&nbsp; </p>
</body>
</html>
